#include "JacQL_Header.h"

int saveDatabaseExternal(unsigned int constraints, ...)
{
    va_list argptr;
    try
    {
        if(constraints==0)
            saveDatabase();
        else
        {
            va_start(argptr, constraints);
            for(unsigned int i=0; i<constraints; i++)
                saveDatabase((dependency)(va_arg(argptr, int)));
            va_end(argptr);
        }
    }
    catch(InvalidFileException e)
    {
        return 1;
    }
    return 0;
}

int copyBitmap(const char *original, const char *destinationPath, unsigned int idOfParent)
{
    char *tempStr = new char[strlen(destinationPath)+15]; //Space for id and .bmp
    sprintf(tempStr, "%s%u.bmp", destinationPath, idOfParent);
    ios::openmode modeIn = ios::in | ios::binary;
    ios::openmode modeOut = ios::out | ios::trunc | ios::binary;
    ifstream inStream(original, modeIn);
    if(!inStream)
    {
        return 1;
    }
    ofstream outStream(tempStr, modeOut);
    if(!outStream)
    {
        inStream.close();
        return 2;
    }
    outStream << inStream.rdbuf();
    outStream.close();
    inStream.close();
    return 0;
}

const char *createPathById(unsigned int id, const char *directory)
{
    static char *path=NULL;
    static unsigned int pathArraySize=0;
    if(pathArraySize<strlen(directory)+15)
    {
        pathArraySize = strlen(directory)+15;
        if(path!=NULL)
            delete[] path;
        path = new char[pathArraySize];
    }
    sprintf(path, "%s%u.bmp", directory, id);
    return path;
}
