#ifndef JACQL_HEADER_H_INCLUDED
#define JACQL_HEADER_H_INCLUDED

/** Central Header - JacQL
  *
  *  By JackTex, 2016. All copyright reserved.
  *
  *  Include this header in the individual table headers. No more includes are needed.
  *  DO NOT use other header files as this might lead to a dependency issue!
  *
  *  If you access specific database tables in the code include their corresponding header
  *  (this header will be provided through the include too).
  *  If you wish to use generic database functions in your code -like the ones provided in
  *  JacQL_Extra.cpp- simply include this header.
  *
  *  Don't forget to set up the custom files too!.
  *
  *  You can use the custom exception to throw exceptions in your database tables.
  *  Do not throw other JacQL_Exceptions as this might lead to confusion!
  **/

//All fundamental necessary Headers:
#include "JacQL_Custom.h"
#include "InvalidFileException.h"

//Prototypes
  //In JacQL_Custom.cpp
    void deleteEntryInDatabase(dependency ownEntry, unsigned int targetId);
    void updateEntryInDatabase(dependency ownEntry, unsigned int old_id, unsigned int new_id);
    void saveDatabase(dependency d = D_ENDTAG) throw(InvalidFileException);
    int loadDatabase(dependency d = D_ENDTAG);
  //In JacQL_ConvertToQuery.cpp
    const wchar_t *ctq(const wchar_t *preString, const char *text);
    const wchar_t *ctq(const wchar_t *preString, const wchar_t *text);
    const wchar_t *ctq(const wchar_t *preString, const int num);
    const wchar_t *ctq(const wchar_t *preString, const unsigned int num);
    const wchar_t *ctq(const wchar_t *preString, const long num);
    const wchar_t *ctq(const wchar_t *preString, const unsigned long num);
    const wchar_t *ctq(const wchar_t *preString, const double num);
    const wchar_t *ctq(const wchar_t *preString, const bool b);
  //In JacQL_Extra.cpp
    int saveDatabaseExternal(unsigned int constraints=0, ...);
    int copyBitmap(const char *original, const char *destinationPath, unsigned int idOfParent); //Directories have
    const char *createPathById(unsigned int id, const char *directory); //to finish with trailing slash!

//Further fundamental Header:
#include "JacQL_Association.h"

//////////////////////////////////////////////////////////////////////////////////////////////////////
// * * * Custom Exception * * * //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

class JacQLException_Custom : public JacQLException
{
    public:
        JacQLException_Custom(const char *desc) : JacQLException(desc) {;}
};


#endif // JACQL_HEADER_H_INCLUDED
